//--------------------------------------------------------------------//
// tBO

var canvas;			// LoXvf
var context;	 		// ReLXg
var mimg=[];			// ό`p摜z
var waitTime;			// ֑ؑ҂
var morphTime;			// ό`v
var isMorphing;			// tBȌꍇ true
var image;			// `p摜
var deform;			// 摜ό`
var step;			// Xebv
var t0;				// 
var img1,img2;			// ό`OEό`̉摜̃CfbNX
var finished;			// ό`XCb`

// tBO
// fileNames - f[^t@Cz
// parameters - ep[^
//   waitTime - ֑ؑ҂
//   morphTime - ό`v
//   threshold - wi臒l
//   type - tBO^fB]u
function initMorphing(fileNames,parameters){
  waitTime=parameters.waitTime;
  if(waitTime===undefined) waitTime=2000;
  morphTime=parameters.morphTime;
  if(morphTime===undefined) morphTime=2000;
  var threshold=parameters.threshold;
  if(threshold===undefined) threshold=40;
  var type=parameters.type;
  if(type===undefined) type='morphing';
  isMorphing=(type.toLowerCase().indexOf('dissolv')<0);
  img1=0;
  img2=1;
  step=0;
  initCanvas();
  readImageFiles(fileNames,threshold);
}

// LoX
function initCanvas(){
  canvas=document.getElementById('morph');
  canvas.width=canvas.clientWidth;
  canvas.height=canvas.clientHeight;
  context=canvas.getContext('2d');
  image=context.createImageData(canvas.width,canvas.height);
}

// 摜t@Cǂݍ
// fileNames - f[^t@Cz
// threshold - wi臒l
function readImageFiles(fileNames,threshold){
  var img=[],loaded=0;
  mimg.length=0;
  for(var i=0;i<fileNames.length;i++){
    img[i]=new Image();
    img[i].src=fileNames[i];
    img[i].onload=loadImage();
  }
// ǂݍ݊摜mF
  function loadImage(){
    loaded++;
    if(loaded==fileNames.length){
      setTimeout(setMorphImage,100);
    }
  }
// S摜ǂݍ݊ɕό`p摜ݒ肷
  function setMorphImage(){
    for(var i=0;i<img.length;i++){
      mimg[i]=new MorphImage(img[i],threshold);
    }
    setDeform();
    t0=new Date();
    loop();
  }
}

// 摜ό`ݒ肷
function setDeform(){
  if(isMorphing){
    deform=new Morphing(mimg[img1],mimg[img2]);
  }
  else{
    deform=new Dissolve(mimg[img1],mimg[img2]);
  }
  finished=false;
}

// [v֐
function loop(){
  step++;
  var t=(new Date())-t0;
  if(t<morphTime){
    deform.createPixel(t/morphTime);
    context.putImageData(image,0,0);
  }
  else if(t<morphTime+waitTime){
    if(!finished){
      deform.createPixel(1);
      context.putImageData(image,0,0);
      finished=true;
    }
  }
  else{
    img1=img2;
    img2=(img2+1)%mimg.length;
    setDeform();
    step=0;
    t0=new Date();
  }
  requestAnimationFrame(loop);
}

// pNX쐬
// ctor - VNX
// superCtor - pNX
function inherits(ctor,superCtor){
  if((ctor===undefined) || (ctor===null))
    throw new TypeError('The constructor to `inherits` must not be '+
                        'null or undefined.');

  if((superCtor===undefined) || (superCtor===null))
    throw new TypeError('The super constructor to `inherits` must '+
                        'not be null or undefined.');

  if(superCtor.prototype===undefined)
    throw new TypeError('The super constructor to `inherits` must '+
                        'have a prototype.');
  ctor.super_=superCtor;
  Object.setPrototypeOf(ctor.prototype,superCtor.prototype);
}

//--------------------------------------------------------------------//
// ό`C[W
// img - 摜f[^
// threshold - wi臒l
var MorphImage=function(img,threshold){
  this.pixel=getPixel(img);		// 摜sNZf[^
  this.width=img.width;			// 摜
  this.height=img.height;		// 摜
// ό`Ώۂx,yW,,
  this.figureX=[];
  var i;
  for(i=0;i<this.width;i++){
    this.figureX[i]=[];
  }
  this.figureY=[];
  this.figureW=[];
  this.figureH=0;
// wiF
  this.bgColor=[this.pixel[0],this.pixel[1],this.pixel[2],this.pixel[3]];
  var thres2=threshold*threshold;
  for(var j=0;j<this.height;j++){
    var ii=0;
    for(i=0;i<this.width;i++){
      var idx=4*(this.width*j+i);
      var dr=this.pixel[idx]-this.bgColor[0];
      var dg=this.pixel[idx+1]-this.bgColor[1];
      var db=this.pixel[idx+2]-this.bgColor[2];
      var dist=dr*dr+dg*dg+db*db;
      if(dist>=thres2){
      	this.figureX[ii][j]=i;
      	ii++;
      }
    }
    if(ii!==0){
      this.figureY[this.figureH]=j;
      this.figureH++;
      this.figureX[ii][j]=this.figureX[ii-1][j]+1;
    }
    this.figureW[j]=ii;
  }
  this.figureY[this.figureH]=this.figureY[this.figureH-1]+1;
};

// 摜sNZf[^𒊏o
// img - 摜f[^
function getPixel(img){
  var pixCanvas=document.createElement('canvas');
  pixCanvas.width=img.width;
  pixCanvas.height=img.height;
  var pixCont=pixCanvas.getContext('2d');
  pixCont.drawImage(img,0,0);
// 摜sNZf[^
  return pixCont.getImageData(0,0,img.width,img.height).data;
}

//--------------------------------------------------------------------//
// 摜ό`
// img1,img2 - ό`OEό`̉摜f[^
var Deform=function(img1,img2){
  this.img1=img1;
  this.img2=img2;
  this.width=img1.width;
  this.height=img1.height;
};

// 摜
// t - }p[^ (0 ` 1 ͈̔)
Deform.prototype.setPixelBase=function(t){
  this.width=inter(t,this.img1.width,this.img2.width);
  this.height=inter(t,this.img1.height,this.img2.height);
  var r=inter(t,this.img1.bgColor[0],this.img2.bgColor[0]);
  var g=inter(t,this.img1.bgColor[1],this.img2.bgColor[1]);
  var b=inter(t,this.img1.bgColor[2],this.img2.bgColor[2]);
  var a=inter(t,this.img1.bgColor[3],this.img2.bgColor[3]);
  var pix=image.data,size=4*image.width*image.height;
  for(var i=0;i<size;i+=4){
    pix[i]=r;
    pix[i+1]=g;
    pix[i+2]=b;
    pix[i+3]=a;
  }
};

// l}
// t - }p[^
// p1 - l 1
// p2 - l 2
function inter(t,p1,p2){
  return parseInt(Math.round(p1+(p2-p1)*t));
}

//--------------------------------------------------------------------//
// tBO
// img1,img2 - ό`OEό`̉摜f[^
var Morphing=function(img1,img2){
  Deform.call(this,img1,img2);
};

// 摜
// t - }p[^ (0 ` 1 ͈̔)
Morphing.prototype.createPixel=function(t){
  this.setPixelBase(t);
  var figureH=Math.max(this.img1.figureH,this.img2.figureH);
  var ddy1=this.img1.figureH/figureH;
  var ddy2=this.img2.figureH/figureH;

  var pix1=this.img1.pixel,pix2=this.img2.pixel,pix=image.data;
  for(var j=0;j<figureH;j++){
    var dy1=ddy1*j;
    var dy2=ddy2*j;
    var j1=parseInt(dy1);
    var j2=parseInt(dy2);
    var y1=this.img1.figureY[j1];
    var y2=this.img2.figureY[j2];
    dy1+=y1-j1;
    dy2+=y2-j2;
    var y=inter(t,dy1,dy2);
    var dx=Math.max(this.img1.figureW[y1],this.img2.figureW[y2]);
    var ddx1=this.img1.figureW[y1]/dx;
    var ddx2=this.img2.figureW[y2]/dx;
    for(var i=0;i<dx;i++){
      var dx1=ddx1*i;
      var dx2=ddx2*i;
      var i1=parseInt(dx1);
      var i2=parseInt(dx2);
      var x1=this.img1.figureX[i1][y1];
      var x2=this.img2.figureX[i2][y2];
      dx1+=x1-i1;
      dx2+=x2-i2;
      var x=inter(t,dx1,dx2);
      var idx1=4*(y1*this.img1.width+x1);
      var idx2=4*(y2*this.img2.width+x2);
      var idx=4*(y*image.width+x);
      pix[idx]=inter(t,pix1[idx1],pix2[idx2]);
      pix[idx+1]=inter(t,pix1[idx1+1],pix2[idx2+1]);
      pix[idx+2]=inter(t,pix1[idx1+2],pix2[idx2+2]);
      pix[idx+3]=inter(t,pix1[idx1+3],pix2[idx2+3]);
    }
  }
};

//--------------------------------------------------------------------//
// fB]u
// img1,img2 - ό`OEό`̉摜f[^
var Dissolve=function(img1,img2){
  Deform.call(this,img1,img2);
};

// 摜
// t - }p[^ (0 ` 1 ͈̔)
Dissolve.prototype.createPixel=function(t){
  this.setPixelBase(t);
  var ddx1=this.img1.width/this.width;
  var ddx2=this.img2.width/this.width;
  var ddy1=this.img1.height/this.height;
  var ddy2=this.img2.height/this.height;
  var pix1=this.img1.pixel,pix2=this.img2.pixel,pix=image.data;
  for(var j=0;j<this.height;j++){
    var y1=parseInt(ddy1*j);
    var y2=parseInt(ddy2*j);
    for(var i=0;i<this.width;i++){
      var x1=parseInt(ddx1*i);
      var x2=parseInt(ddx2*i);
      var idx1=4*(y1*this.img1.width+x1);
      var idx2=4*(y2*this.img2.width+x2);
      var idx=4*(j*image.width+i);
      pix[idx]=inter(t,pix1[idx1],pix2[idx2]);
      pix[idx+1]=inter(t,pix1[idx1+1],pix2[idx2+1]);
      pix[idx+2]=inter(t,pix1[idx1+2],pix2[idx2+2]);
      pix[idx+3]=inter(t,pix1[idx1+3],pix2[idx2+3]);
    }
  }
};

inherits(Morphing,Deform);
inherits(Dissolve,Deform);
